package Tietorakenteet;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 * @author MHo
 * @version 20.2.2020
 * Jasen -luokka, joka lisää jäsenen rekisteriin.
 */
public class Jasen {
    private int id;
    private String nimi = "";
    private String syntAika = "";
    private String pKunta = "";
    private int puh;
    private String sPosti = "";
    private int liittymisV;
    
    private static int juoksevaNro = 1;
    
    
    /**
     * Muodostaja
     */
    public Jasen(){
        id = juoksevaNro;
        nimi = "Nokka Räkä";
        syntAika = "01.08.1960";
        pKunta = "Lahti";
        puh = 0401234567;
        sPosti = "nr@niilot.fi";
        liittymisV = 1980;
        juoksevaNro++;
    }
    
    
    /**
     * @return jäsenen nimi
     */
    public String getNimi(){
        return nimi;
    }
    
    /**
     * @return jäsenen ID-numero
     */
    public int getID() {
        return id;
    }
    
    /**
     * Tulostetaan henkilön tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("%03d", id, 3) + "  " + nimi);
        out.println("  " + syntAika + "  " + pKunta + " " + puh + "  " + sPosti);
        out.print("  Liittynyt " + liittymisV + ".");
    }
    
    
    /**
     * Tulostetaan henkilön tiedot
     * @param os tietovirta johon tulostetaan
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }

    
    /**
     * @param args ei käytössä
     */
    public static void main(String args[]) {
        Jasen nokka = new Jasen();
        nokka.tulosta(System.out);
    }
}