package Tietorakenteet;

import java.util.*;

/**
 * @author MHo
 * @version 20.2.2020
 * Hiihtorekisterin jasenet, joka lisää ja poistaa jäseniä.
 */
public class Rekisteri {
    private  final Jasenet jasenet = new Jasenet();
    
    
    /**
     * Muodostaja
     */
    public Rekisteri(){
    }
    
    
    /**
     * Lisää jäsenen listaan.
     * @param jasen lisättävän jäsenen viite
     * @throws SailoException jos lisäystä ei voida tehdä 
     */
    public void lisaa(Jasen jasen) throws SailoException {
        jasenet.lisaa(jasen);
    }
    
    
    /**
     * @param i monennenko jäsenen viite haetaan
     * @return viite jäseneen, jonka indeksi on i
     */
    public Jasen annaJasen(int i) {
        return jasenet.anna(i);
    }
    
    
    /**
     * Lukee jäsenistön tiedostosta. TODO lukeminen tiedostosta
     * @param nimi jota käytetään lukemisessa
     * @throws SailoException jos lukeminen epäonnistuu
     */
    public void lueTiedostosta(String nimi) throws SailoException {
        jasenet.lueTiedostosta(nimi);
    }
    
    
    /**
     * Poistaa jäsenet ja hiihdot, joilla on annettu nro
     * TODO jäsenien ja hiihtojen poisto ko. luokista. 
     * @throws SailoException jos tallettamisessa ongelmia
     */
    public void talleta() throws SailoException{
        jasenet.talleta();
    }
    
    
    /**
     * @return jäsenistön lkm
     */
    public int getLkm() {
        return jasenet.getLkm();
    }
    /**
     * @param args ei käytössä
     */
    public static void main(String args[]) {
        Rekisteri rekisteri = new Rekisteri();
        
        try {
            // kerho.lueTiedostosta("kelmit");

            Jasen nokkaraka = new Jasen(), mietaa = new Jasen();
            

            rekisteri.lisaa(nokkaraka);
            rekisteri.lisaa(mietaa);

            System.out.println("============= Kerhon testi =================");

            for (int i = 0; i < rekisteri.getLkm(); i++) {
                Jasen jasen = rekisteri.annaJasen(i);
                System.out.println("Jäsen paikassa: " + i);
                jasen.tulosta(System.out);
            }

        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }
}